﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2012/02/29														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://www.geocities.jp/dij4121/alpha/							*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2011/05/16	tamakoroベースに作成開始	2008/05/22	tamakoro 初版をベース	*/
/*	2012/07/07	ver 0.90リリース												*/
/*	2012/07/14	ver 1.00														*/
/*	2012/08/03	ver 1.02														*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用     #00A変数設定はここ～
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int mode; 						//ゲームのモード
	int main_bgm; 					//曲のセレクト
	int hi_score[10] = 0;			//ハイスコア
	int game_score = 0;				//スコア
	int game_time_count = 0;		//ゲーム終了までの残り時間

	float zoome = 0.5;				//マップのズーム
	int ani_count = 0;				//アニメカウンタ
	int ani_frame = 0;				//変化フレーム数
	int field_deg = 0;				//方角
	int char_size = 16;				//キャラ画像サイズ
	int shot_on = 0;				//ショット表示フラグ
	int life = 100;					//自機生命力
	int combo = 0;					//コンボ
	int burst = 0;					//爆発コンボ
	int combo_timer= 0;				//コンボ時間
	int burst_timer= 0;				//バースト時間
	int enemy_count = 0;			//敵精製カウンタ
	int enemy_count2 = 0;			//敵精製カウンタ
	int autoshot_wait = 0;			//Autoショットカウンタ
	int charge_on = 0;				//ChargeショットON
	int charge_wait = 0;			//ChargeショットON
	int turn_wait = 0;				//反転ウェイト
	
	int level_deg = 90;				//レベル1 範囲

	int loop_j;						//汎用ループ
	int loop_k;						//汎用ループ
	int loop_m;						//汎用ループ

	int test1;						//debug
	int test2;						//debug
	int test3;						//debug
	int test4;						//debug
	
	struct UNIT	{
				float x;						//x座標
				float y;						//y座標
				int muki;						//向き 右1 左-1
				int size;						//中央までの距離
				int ani;						//アニメフレーム
				int status;						//状態 0立ち 1歩き 3忍歩き 4忍立ち 5降 6張 21飛 32失敗 33成功
				}

	UNIT player[2];
	
	struct Shotstatus	{
				 int type;						//敵タイプ、消滅、弾、敵
				 int num;						//数字
				 float deg;						//角度
				 float distance;				//距離
				 float reach;					//着弾距離
				 float move;					//移動 左右移動
				 float size;					//大きさ
				 int atk;						//攻撃力
				 int hp;						//耐久力
				 float speed;					//速度
				 int wait;						//表示時間

				}
	
	Shotstatus shot[100];

	Shotstatus enemy[500];
	
	int point_count;
	
	struct Pointstatus
	{
		int score;
		int wait;
		int x;
		int y;
	}
	
	Pointstatus point[100];
	
	//位置構造体
	struct POS
	{
		float x;
		float y;
	}
	//エフェクト用構造体☆☆☆
	struct EFFECT_DATA
	{
		int exist;		//存在
		int type;		//透明度
		int timer;		//生存時間
		float pos_x;	//位置
		float pos_y;	//位置
		float size;		//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		int dec_alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
		int move[10];	//汎用バッファ
	};
	const int EFFECT_MAX = 1024;
	EFFECT_DATA effect[EFFECT_MAX];

	
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化     #01
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	シーンの初期化 	
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("aira","resource/image/player.bmp" , [0,255,0]);

		
		
		Hell_loadTexture("tama","resource/image/tama.bmp" , [0,255,0]);
		Hell_loadTexture("map1","resource/image/map1.bmp" , [0,255,0]);
		Hell_loadTexture("waku","resource/image/waku.bmp" , [0,255,0]);
		Hell_loadTexture("char","resource/image/char1.bmp" , [0,255,0]);
		Hell_loadTexture("ball","resource/image/effect_ball.bmp" , [0,0,0]);
		Hell_loadTexture("shot","resource/image/effect_shot.bmp" , [0,0,0]);
		Hell_loadTexture("atk","resource/image/effect_atk.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");
		Hell_loadWAV("miss",        "resource/sound/damage.wav");
		Hell_loadWAV("select",      "resource/sound/select.wav");
		Hell_loadWAV("cancel",      "resource/sound/puwa.wav");
		Hell_loadWAV("destroy",     "resource/sound/destroy2.wav");
		Hell_loadWAV("powerup",     "resource/sound/clear.wav");
		Hell_loadWAV("bom1",        "resource/sound/mm_bom19_a.wav");
		Hell_loadWAV("bom2",        "resource/sound/mm_don00.wav");
		Hell_loadWAV("bom2",        "resource/sound/mm_freeze04.wav");
		Hell_loadWAV("bom3",        "resource/sound/mm_bom30.wav");
		Hell_loadWAV("shot",        "resource/sound/mm_shoot04.wav");
		Hell_loadWAV("turn",        "resource/sound/atk1.wav");
		Hell_loadWAV("life",        "resource/sound/life.wav");
		Hell_loadWAV("alert",       "resource/sound/mm_alarm01.wav");

		// koizumi start☆☆☆
		//エフェクト画像を追加
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		// koizumi end

		
		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.set("HI_SCORE1",         999999);
			savedata.set("HI_SCORE2",         999999);
			savedata.set("HI_SCORE3",         999999);
			savedata.set("HI_SCORE4",         999999);
			savedata.set("HI_SCORE5",         999999);
			savedata.set("HI_SCORE6",         999999);
			savedata.set("HOSHI",         1);
			savedata.set("SELECT_HOSHI",	 main_bgm);
			savedata.write();
		}
		hi_score[0] = savedata.getint("HI_SCORE");
		hi_score[1] = savedata.getint("HI_SCORE1");
		hi_score[2] = savedata.getint("HI_SCORE2");
		hi_score[3] = savedata.getint("HI_SCORE3");
		hi_score[4] = savedata.getint("HI_SCORE4");
		hi_score[5] = savedata.getint("HI_SCORE5");
		hi_score[6] = savedata.getint("HI_SCORE6");

		game_time_count = 60*60*3;		//ゲーム終了までの残り時間
		mode = 1;						//ゲームモード
		main_bgm = Hell_GetGameflag(10);	//ゲームモード

	//初期ステータス決定
	int j;
	int k;

		player[0].x = 250;
		player[0].y = 250;
		player[0].muki = 1;
		player[0].size = 16;
		
		
			
		for ( loop_m = 0 ; loop_m < 0 ; loop_m++ )	//敵マップ配置(初期配置型)
		{
			enemy[loop_m].type 		= 1;
			enemy[loop_m].num 		= loop_m;
			enemy[loop_m].deg 		= Hell_randInt(0, level_deg) + 270 - level_deg/2;
			enemy[loop_m].distance 	= loop_m*50+200;
			enemy[loop_m].move 		= 0;
			enemy[loop_m].size 		= Hell_randInt(2, 6);
			enemy[loop_m].atk 		= 1;
			enemy[loop_m].hp 		= cast(int)enemy[loop_m].size;	//デカけりゃHP高いだろ的セッティング
			enemy[loop_m].speed 	= Hell_randInt(1, 3) * 0.5;
			enemy[loop_m].wait 		= 1;

			
			if ( loop_m % 10 == 9 )		//固い奴
			{
			enemy[loop_m].type 		= 2;
//			enemy[loop_m].move 		= ( Hell_randInt(0, 3) - 1 ) ;	//左右移動
			enemy[loop_m].size 		= 3;
			enemy[loop_m].atk 		= 1;
			enemy[loop_m].hp 		= 15;
			enemy[loop_m].speed 	= 0.5;
			}
			
//			enemy[loop_m].move 		= ( Hell_randInt(0, 3) - 1 ) ;	//左右移動
			enemy[loop_m].deg 		= 270;
//			enemy[loop_m].deg 		= loop_m*10;
//			enemy[loop_m].size 		= 5;
//			enemy[loop_m].size 		= 5;
//			enemy[loop_m].distance 	= loop_m*50+200;
//			enemy[loop_m].speed 	= 0.5;
			enemy[loop_m].speed 	= 0;
//			enemy[loop_m].distance 	= 100;
			
			
		}

		
		

		
Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 2 ) )
		{
			stage_start_count++;
		}
		else 
		{
			if ( main_bgm == 1 )
			{
				Hell_playBgm( "resource/sound/bgm_dong_robiopsys.ogg", -1, 0 );
			}
			else if ( main_bgm == 2 )
			{
				Hell_playBgm( "resource/sound/bgm_dong_nb2.ogg", -1, 0 );
			}
			else if ( main_bgm == 3 )
			{
				Hell_playBgm( "resource/sound/bgm_eki_pn.ogg", -1, 0 );
			}
			else
			{
				Hell_playBgm( "resource/sound/bgm_dong_robiopsys.ogg", -1, 0 );
			}
			
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 1 ) )
		{
			Hell_drawFont(" GO! " , 160, 180 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 155, 180 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( ( stage_clear_count > ( 60 * 2 ) ) || ( ( keypad.isPushEnter() == 1 ) && ( stage_clear_count > 30 ) ) )
		{
//			if(Hell_isPushMouse() & HELL_BUTTON_LEFT)
			if(keypad.isPushEnter())		//１ボタン
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	クリア演出の表示 #
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);

		Hell_drawFont( "RESULTS" , 120, 160 , 4 , 255,255,255);
		Hell_drawFont( "SCORE" ,    185, 200 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 140, 230 , 4 , 255,255,255);
		if ( hi_score[mode] <= game_score )
		{
			Hell_drawFont( " NEW RECORD ",85, 280 , 3 , 255,50,50);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS Z(1) TO EXIT" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
//			Hell_drawFont(" OWARI !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
//			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理 #20A
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		int j;
		//残り時間のカウント
		game_time_count--;
		
		player_move();
		enemy_move();
		shot_move();
		level_make();
		
//		if(Hell_isPushMouse() & HELL_BUTTON_LEFT)	//マウス左クリック
//		{
//		}
		
			if ( game_time_count <=0 ) 
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
//			game_score = game_time_count;
			if ( ( hi_score[0] < game_score ) && ( mode == 0 ) )
			{
				keypad.save( "replay/replay_00.bin" );	//リプレイの保存
				hi_score[0] = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score[0]);
				savedata.write();
			}
			if ( ( hi_score[1] < game_score ) && ( mode == 1 ) )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score[1] = game_score;
				savedata.set("HI_SCORE1",   cast(int)hi_score[1]);
				savedata.write();
			}
			if ( ( hi_score[2] < game_score ) && ( mode == 2 ) )
			{
				keypad.save( "replay/replay_02.bin" );	//リプレイの保存
				hi_score[2] = game_score;
				savedata.set("HI_SCORE2",   cast(int)hi_score[2]);
				savedata.write();
			}
			if ( ( hi_score[3] < game_score ) && ( mode == 3 ) )
			{
				keypad.save( "replay/replay_03.bin" );	//リプレイの保存
				hi_score[3] = game_score;
				savedata.set("HI_SCORE3",   cast(int)hi_score[3]);
				savedata.write();
			}
			if ( ( hi_score[4] < game_score ) && ( mode == 4 ) )
			{
				keypad.save( "replay/replay_04.bin" );	//リプレイの保存
				hi_score[4] = game_score;
				savedata.set("HI_SCORE4",   cast(int)hi_score[4]);
				savedata.write();
			}
			if ( ( hi_score[5] < game_score ) && ( mode == 5 ) )
			{
				keypad.save( "replay/replay_05.bin" );	//リプレイの保存
				hi_score[5] = game_score;
				savedata.set("HI_SCORE5",   cast(int)hi_score[5]);
				savedata.write();
			}
			if ( ( hi_score[6] < game_score ) && ( mode == 6 ) )
			{
				keypad.save( "replay/replay_06.bin" );	//リプレイの保存
				hi_score[6] = game_score;
				savedata.set("HI_SCORE6",   cast(int)hi_score[6]);
				savedata.write();
			}
				savedata.set("SELECT_HOSHI",   cast(int)main_bgm);
				savedata.write();

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
//				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	主人公の制御 	110503-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void player_move( )
	{
		ani_frame = 5;
		ani_count++;
		if (ani_count >= ani_frame )
		{
			ani_count = 0;
			player[0].ani++;
			if (player[0].ani >=3 )
			{
				player[0].ani=0;
			}
		}
		
		
		if ((keypad.isPressRight() == 0 ) && (keypad.isPressLeft()) == 0 )	//ニュートラル
		{
//			Hell_playWAV( "door", 0, -1 );
			player[0].status = 0;
		}
		
		if (keypad.isPressRight())		//コマンド→
		{
			player[0].muki = 1;
			if ( player[0].status == 0 )
			{
			player[0].status = 1;
			}
			field_deg = field_deg - cast(int)zoome*3-1;
			if ( field_deg < 0 )
			{
				field_deg = field_deg + 360;
			}
		} 

		if (keypad.isPressLeft())		//コマンド←
		{
			player[0].muki = -1;
			if ( player[0].status == 0 )
			{
			player[0].status = 1;
			}
			field_deg = field_deg + cast(int)zoome*3+1;
			if ( field_deg >= 360 )
			{
				field_deg = field_deg - 360;
			}
		} 

/*
		if (keypad.isPressUp())			//コマンド↑
		{
			zoome = zoome + 0.1;
			if ( zoome >= 2 ) 
			{
				zoome = 2;
			}
		} 

		if (keypad.isPressDown())		//コマンド↓
		{
			zoome = zoome - 0.1;
			if ( zoome <= 0.5 ) 
			{
				zoome = 0.5;
			}
		} 
*/
		
		if ( (keypad.isPressDown()) && ( turn_wait == 0 ) )		//コマンド↓反転
		{
			turn_wait = 18;
			Hell_playWAV( "turn", 0, -1 );	//反転
		}
		
		if ( turn_wait > 0 )
		{
			turn_wait--;
			
			field_deg = field_deg + 10;
			if ( field_deg >= 360 )
			{
				field_deg = field_deg - 360;
			}
		}

		if(keypad.isPushEnter())		//1ボタン shot
		{

			shot_on = 0;
			for ( loop_m = 0 ; loop_m < 100 ; loop_m ++ )
			{
				if (  ( shot[loop_m].type == 0 ) && ( shot_on == 0 ) )
				{
				shot_on = 1;
				
				shot[loop_m].type 		= 1;
				shot[loop_m].num 		= loop_m;
				shot[loop_m].deg = 270 - field_deg ;
				shot[loop_m].distance 	= 16 * zoome;
//				shot[loop_m].reach	 	= 240 / zoome;
				shot[loop_m].reach	 	= 480;
				shot[loop_m].move 		= 0;
				shot[loop_m].size 		= 1.5;			//zoome*3;
				shot[loop_m].atk 		= 6;			//cast(int)((3-zoome)*3)-2;
				shot[loop_m].hp 		= 1;
				shot[loop_m].speed 		= 20;
				shot[loop_m].wait 		= 0;
					
				Hell_playWAV( "shot", 0, -1 );
					
				autoshot_wait = 0;
				}
			}
		}
		if(keypad.isPressEnter())		//1ボタン
		{
			
			if ( autoshot_wait < 8 )
			{
				autoshot_wait ++ ;
			}
			else
			{
				shot_on = 0;
				for ( loop_m = 0 ; loop_m < 100 ; loop_m ++ )
				{
					if (  ( shot[loop_m].type == 0 ) && ( shot_on == 0 ) )
					{
					shot_on = 1;
					
					shot[loop_m].type 		= 1;
					shot[loop_m].num 		= loop_m;
					shot[loop_m].deg = 270 - field_deg ;
					shot[loop_m].distance 	= 16 * zoome;
	//				shot[loop_m].reach	 	= 240 / zoome;
					shot[loop_m].reach	 	= 480;
					shot[loop_m].move 		= 0;
					shot[loop_m].size 		= 1.5;			//zoome*3;
					shot[loop_m].atk 		= 6;			//cast(int)((3-zoome)*3)-2;
					shot[loop_m].hp 		= 1;
					shot[loop_m].speed 		= 20;
					shot[loop_m].wait 		= 0;
						
					Hell_playWAV( "shot", 0, -1 );
					}
				}
				autoshot_wait = 0;
			}
		}
		
		if(keypad.isPushCancel())		//2ボタン 溜めshot
		{
			charge_wait = 0;
		}
		
		if(keypad.isPressCancel()) 		//2ボタン 
		{
			if ( charge_on == 2 )
			{
				zoome = zoome - 0.1;
				if ( zoome <= 0.5 ) 
				{
					zoome = 0.5;
					charge_on = 0;
				}
			}
			else
			{
				charge_on = 1;
				charge_wait= charge_wait + 10;
				if ( charge_wait >= 250 )
				{
					charge_wait = 250;
					zoome = zoome + 0.05;
					if ( zoome >= 2 ) 
					{
						zoome = 2;
					}
				}
			}
		}
		else if ( ( charge_on == 1 ) && ( charge_wait < 250 ) )
		{
			charge_on = 2;
			shot_on = 0;
			for ( loop_m = 0 ; loop_m < 100 ; loop_m ++ )
			{
				if (  ( shot[loop_m].type == 0 ) && ( shot_on == 0 ) )
				{
				shot_on = 1;
				
				shot[loop_m].type 		= 1;
				shot[loop_m].num 		= loop_m;
				shot[loop_m].deg = 270 - field_deg ;
				shot[loop_m].distance 	= 16 * zoome;
//				shot[loop_m].reach	 	= 
				shot[loop_m].reach	 	= 480;			//240 / zoome;
				shot[loop_m].move 		= 0;
				shot[loop_m].size 		= 1.5;			//zoome*3;
				shot[loop_m].atk 		= 6;			//cast(int)((3-zoome)*3)-2;
				shot[loop_m].hp 		= 1;
				shot[loop_m].speed 		= 20;
				shot[loop_m].wait 		= 0;
					
				Hell_playWAV( "shot", 0, -1 );
				}
			}
		}
		else if ( charge_on == 1 )
		{
			charge_on = 2;
			for ( loop_k = 0 ; loop_k < 6 ; loop_k ++ )
			{
				shot_on = 0;
				for ( loop_m = 0 ; loop_m < 100 ; loop_m ++ )
				{
					if (  ( shot[loop_m].type == 0 ) && ( shot_on == 0 ) )
					{
						shot_on = 1;
						
						shot[loop_m].type 		= 2;
						shot[loop_m].num 		= loop_m;
						shot[loop_m].deg = 270 - field_deg ;
						shot[loop_m].distance 	= 16 * zoome - loop_k * 10 *zoome;
						shot[loop_m].reach	 	= 480;						//240 / zoome;
						shot[loop_m].move 		= 0;
						shot[loop_m].size 		= zoome * 3 / 6 * ( 6 - loop_k );
						shot[loop_m].atk 		= cast(int)(zoome * 3);	//cast(int)((3-zoome)*3)-2;
						shot[loop_m].hp 		= 1;
						shot[loop_m].speed 		= 10;	//	( 2.5 - zoome ) * 10;
						shot[loop_m].wait 		= 0;
							
						Hell_playWAV( "shot", 0, -1 );
//						test1 = cast(int)shot[loop_m].atk;
						if ( zoome == 2 )
						{
							shot[loop_m].atk 	= 999;
						}
					}
				}
			}
		}
		else
		{
			zoome = zoome - 0.1;
			if ( zoome <= 0.5 ) 
			{
				zoome = 0.5;
				charge_on = 0;
			}
		}
		
		if (Hell_isPushJButton(2,0))	//3ボタン　キーボードの割り当てがわからん(汗
		{
//			Hell_playWAV( "door", 0, -1 );
		}
			
			
		effect_move();
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	enemyの動き 	120523-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void enemy_move( )
	{
		
		for ( loop_m = 0 ; loop_m < 300 ; loop_m ++ )
		{
			
			if ( enemy[loop_m].type > 0 )
			{
				enemy[loop_m].distance = enemy[loop_m].distance - enemy[loop_m].speed;
				
				enemy[loop_m].deg = enemy[loop_m].deg + (enemy[loop_m].move * enemy[loop_m].distance / 500);
				enemy[loop_m].deg = ( enemy[loop_m].deg +360 )% 360;
				
				if ( ( enemy[loop_m].type == 5 ) && ( cast(int)(enemy[loop_m].distance % 100) == 0) ) //ターン
				{
					enemy[loop_m].move = - enemy[loop_m].move;
					enemy[loop_m].distance --;
				}
				if ( ( enemy[loop_m].type == 5 ) && ( cast(int)(enemy[loop_m].distance % 100) > 75) ) //ターン
				{
					enemy[loop_m].deg = enemy[loop_m].deg + (-enemy[loop_m].move * enemy[loop_m].distance / 500);
					enemy[loop_m].distance --;
				}
				
				if ( enemy[loop_m].distance <= 0 + enemy[loop_m].size * 6 )		//自機への接触
				{
					life = life - cast(int)(enemy[loop_m].atk*10);		//自機ダメージ
					Hell_playWAV( "bom3", 0, -1 );
					
						//ヒットエフェクトの追加
						float dir1 = cast( float )Hell_randInt(0, 360 );
						float dir2 = cast( float )Hell_randInt(0, 360 );
						float pos_x = 240.0 + Hell_cosEx( enemy[loop_m].deg + field_deg ) * enemy[loop_m].distance * zoome;
						float pos_y = 240.0 + Hell_sinEx( enemy[loop_m].deg + field_deg ) * enemy[loop_m].distance * zoome;
						create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_ATK, pos_x, pos_y, dir2 + 180, 0, 128, 128, 255 , enemy[loop_m].size/2 );

					if ( life <= 0 )
					{
						life = -1;						//やられる
						game_time_count = 0;
						
						
					}
					enemy[loop_m].type = 0;
					enemy[loop_m].distance = 1000;
					enemy_count2 --;
				}
			}
		}
		
		if ( combo_timer >= 0 )
		{
			combo_timer--;
			if ( ( combo_timer == 0 ) && ( life < 100 )  && ( combo > 100 ) )
			{
				Hell_playWAV( "get", 0, -1 ); //コンボ切れ回復
				create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE, 240, 240, 0, 0, 128, 128, 255 , 16 );
				life = 100;	
			}
		}
		else
		{
			combo = 0;
		}
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	敵生成のレベル作成 	120705-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void level_make( )
	{
		if ( game_time_count % 60 == 0 )	//敵生成率　1秒/体
		{
			int move;
			int deg = Hell_randInt(0, level_deg) - 90 - level_deg/2;
			int form;
			int type = 1;
			enemy_count++;
			level_deg = level_deg + 3;					//敵出現範囲 拡大
			move = ( Hell_randInt(0, 2) * 2 - 1 );		//編隊 移動方向設定
		
			if ( ( game_time_count == 150 * 60 ) && ( game_score >=0 ) )
//			if ( ( game_time_count % 180 == 0 )  )
			{
				type = 11;	//編隊1 ワイド
				form = 10;
			}
			else if ( ( game_time_count == 120 * 60 ) && ( game_score <500000 ) )
			{
				type = 12;	//編隊2 レーザー
				form = 20;
			}
			else if ( ( game_time_count == 120 * 60 ) && ( game_score >=500000 ) )
			{
				type = 11;	//編隊2B ワイド
				form = 20;
			}
			else if ( ( game_time_count == 90 * 60 ) && ( game_score <1000000 ) )
			{
				type = 13;	//編隊3A 前後ワイド
				form = 15;
			}
			else if ( ( game_time_count == 90 * 60 ) && ( game_score >=1000000 ) )
			{
				type = 16;	//編隊3B リング
				form = 36;
			}
			else if ( ( game_time_count == 60 * 60 ) && ( game_score <5000000 ) )
			{
				type = 14;	//編隊4A Vレーザー
				form = 30;
			}
			else if ( ( game_time_count == 60 * 60 ) && ( game_score >=5000000 ) )
			{
				type = 17;	//編隊4B Xレーザー
				form = 40;
			}
			else if ( ( game_time_count == 30 * 60 ) && ( game_score <10000000 ) )
			{
				type = 15;	//編隊5A トルネードリング
				form = 36;
			}
			else if ( ( game_time_count == 30 * 60 ) && ( game_score >=10000000 ) )
			{
				type = 18;	//編隊5B 回転
				form = 36;
			}
			else if ( enemy_count % 9 == 0 )
			{
				type = 6;	//桃　固い奴
				form = 3;
			}
			else if ( enemy_count % 16 == 0 )
			{
				type = 7;	//緑　動く奴1
				form = 3;
			}
			else if ( enemy_count % 25 == 0 )
			{
				type = 8;	//紫　動く奴2
				form = 3;
			}
			else if ( enemy_count % 10 == 5 )
			{
				type = 9;	//赤　動く奴2
				form = 3;
			}
			else if ( enemy_count % 10 == 3 )
			{
				form = 3;
			}
			else if ( enemy_count % 10 == 6 )
			{
				form = 3;
			}
			else if ( enemy_count % 10 == 8 )
			{
				form = 3;
			}
			else if ( enemy_count % 10 == 1 )
			{
				form = 5;
			}
			else
			{
				form = 1;
			}
			
			form = form + ( enemy_count / 60 );
			
			
			for ( loop_k = 0 ; loop_k < form ; loop_k ++ )
			{
				shot_on = 0;
				for ( loop_m = 0 ; loop_m < 300 ; loop_m ++ )
				{
					if (  ( enemy[loop_m].type == 0 ) && ( shot_on == 0 ) )
					{
						shot_on = 1;
						enemy_make ( type, loop_m, loop_k, move, deg );		//enemyの単体精製
					}
				}
			}
		}
		
//		test1 = cast(int)level_deg;
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	enemyの単体精製	120714-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void enemy_make( int type, int num , int form , int move, int deg)
	{
		//基本
		enemy[num].type 	= 1;
		enemy[num].num 		= num;
		enemy[num].deg 		= deg + form * 10;
		enemy[num].distance = 500;
		enemy[num].move 	= 0;
		enemy[num].size 	= Hell_randInt(2, 6);
		enemy[num].atk 		= cast(int)enemy[num].size;
		enemy[num].hp 		= 5;						//cast(int)enemy[num].size;	//デカけりゃHP高いだろ的セッティング
		enemy[num].speed 	= Hell_randInt(1, 3) * 0.3;
		enemy[num].wait 	= 0;
		enemy_count2++;
		
		if ( type == 6 )		//固い奴
		{
			enemy[num].type 	= 2;
			enemy[num].deg 		= deg + form * 10;
			enemy[num].size 	= 3;
			enemy[num].atk 		= cast(int)enemy[loop_m].size;
			enemy[num].hp 		= 15;
			enemy[num].speed 	= 0.5;
		}
		if ( type == 7 )		//動く奴1
		{
			enemy[num].type 	= 3;
			enemy[num].deg 		= deg + form * 10;		//level_deg / 2 - 90 - level_deg/2 + form * 10;
			enemy[num].move 	= move ;	//左右移動
			enemy[num].size 	= 3;
			enemy[num].atk 		= 5;
			enemy[num].speed 	= 0.5;
		}
		if ( type == 8 )		//動く奴2 ターン
		{
			enemy[num].type 	= 5;
			enemy[num].deg 		= deg + form * 10;		//level_deg / 2 - 90 - level_deg/2 + form * 10;
			enemy[num].move 	= move ;	//左右移動
			enemy[num].size 	= 3;
			enemy[num].atk 		= 5;
			enemy[num].speed 	= 0.5;
		}
		if ( type == 9 )		//早い奴
		{
			enemy[num].type 	= 7;
			enemy[num].deg 		= deg;		//level_deg / 2 - 90 - level_deg/2 + form * 10;
			enemy[num].distance = 500 + form * 20;
			enemy[num].size 	= 3;
			enemy[num].atk 		= 5;
			enemy[num].speed 	= 2.0;
		}
		if ( type == 11 )		//編隊1 ワイド
		{
			enemy[num].type 	= 4;
			enemy[num].deg 		= 180 + form *10;
			enemy[num].distance = 500;
			enemy[num].size 	= 5;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 0.5;
			enemy[num].wait 	= 0;
		}
		if ( type == 12 )		//編隊2 レーザー
		{
			enemy[num].type 	= 4;
			enemy[num].deg 		= 180;
			enemy[num].distance = 500 + form * 15;
			enemy[num].size 	= 2;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 1.5;
			enemy[num].wait 	= 0;
		}
		if ( type == 13 )		//編隊3A 前後ワイド
		{
			enemy[num].type 	= 4;
			enemy[num].deg 		= 180 + ( form % 2 )*180 + form *5;
			enemy[num].distance = 500;
			enemy[num].size 	= 5;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 0.3;
			enemy[num].wait 	= 0;
		}
		if ( type == 14 )		//編隊4A Vレーザー
		{
			enemy[num].type 	= 4;
			enemy[num].deg 		= 180 + (form % 2) * 45;
			enemy[num].distance = 500 + form * 15;
			enemy[num].size 	= 2;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 1.0;
			enemy[num].wait 	= 0;
		}
		if ( type == 15 )		//編隊5 Wトルネードリング
		{
			enemy[num].type 	= 4;
			enemy[num].deg 		= 180 + ( form % 2 )*180 + form *5;
			enemy[num].distance = 500 + form *20;
			enemy[num].size 	= 5;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 0.5;
			enemy[num].wait 	= 0;
		}
		if ( type == 16 )		//編隊3B リング
		{
			enemy[num].type 	= 6;
			enemy[num].deg 		= 180 + form *10;
			enemy[num].move 	= move ;	//左右移動
			enemy[num].distance = 500;
			enemy[num].size 	= 5;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 0.3;
			enemy[num].wait 	= 0;
		}
		if ( type == 17 )		//編隊4B Xレーザー
		{
			enemy[num].type 	= 6;
			enemy[num].deg 		= 180 + (form % 4) * 90;
			enemy[num].distance = 500 + form * 5;
			enemy[num].size 	= 2;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 0.5;
			enemy[num].wait 	= 0;
		}
		if ( type == 18 )		//編隊5B 回転
		{
			enemy[num].type 	= 6;
			enemy[num].deg 		= 180 + (form % 2) * 180 + form *5;
			enemy[num].move 	= move ;	//左右移動
			enemy[num].distance = 500 + form * 5;
			enemy[num].size 	= 5;
			enemy[num].atk 		= cast(int)enemy[num].size;
			enemy[num].hp 		= 20;
			enemy[num].speed 	= 0.5;
			enemy[num].wait 	= 0;
		}
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	SHOTの動き 	120611-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void shot_move( )
	{
		int hit_a1;
		int hit_a2;
		int hit_a3;
		int hit_a4;
		int hit_se = 0;
		
		for ( loop_m = 0 ; loop_m < 100 ; loop_m ++ )	//SHOTの動き
		{
			if ( shot[loop_m].wait > 0 )
			{
				shot[loop_m].wait --;
				
				if ( shot[loop_m].type == 99 )
				{
					float dir1 = cast( float )Hell_randInt(0, 360 );
					float dir2 = cast( float )Hell_randInt(0, 360 );
					float pos_x = 240.0 + Hell_cosEx( shot[loop_m].deg + field_deg ) * shot[loop_m].distance * zoome;
					float pos_y = 240.0 + Hell_sinEx( shot[loop_m].deg + field_deg ) * shot[loop_m].distance * zoome;
//					create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE, pos_x, pos_y, dir2 + 180, 0, 128, 128, 255 , shot[loop_m].size/2 );
				
					if ( shot[loop_m].wait <= 0 )
					{
						shot[loop_m].type = 0;
						shot[loop_m].wait = 0;
						shot[loop_m].distance = 1000;
					}
				}
			}
			
			

			
			if ( shot[loop_m].type > 0 )
			{
			shot[loop_m].distance = shot[loop_m].distance + shot[loop_m].speed;
			}
			
			if ( ( shot[loop_m].distance >= shot[loop_m].reach )  ) //SHOTの消滅
			{
				shot[loop_m].type = 0;
			}
			
			for ( loop_j = 0 ; loop_j < 300 ; loop_j ++ )	//敵と弾の接触
			{
				if ( enemy[loop_j].distance < 500 )
				{
					hit_a1 = cast( int )( enemy[loop_j].deg - 400 / enemy[loop_j].distance * enemy[loop_j].size - shot[loop_m].size*2 ) % 360 + 360;
					hit_a2 = cast( int )( enemy[loop_j].deg + 400 / enemy[loop_j].distance * enemy[loop_j].size + shot[loop_m].size*2 ) % 360 + 360;
					hit_a3 = cast( int )( enemy[loop_j].deg - 400 / enemy[loop_j].distance * enemy[loop_j].size - shot[loop_m].size*2 ) % 360 +  0;
					hit_a4 = cast( int )( enemy[loop_j].deg + 400 / enemy[loop_j].distance * enemy[loop_j].size + shot[loop_m].size*2 ) % 360 +  0;

					if ( ( enemy[loop_j].distance - enemy[loop_j].size * 16 <= shot[loop_m].distance - shot[loop_m].speed )
					  && ( enemy[loop_j].distance + enemy[loop_j].size * 16 > shot[loop_m].distance )
						&& (
						   ( ( hit_a1 <= (shot[loop_m].deg ) % 360 + 360 ) && ( hit_a2 >= (shot[loop_m].deg ) % 360 + 360 ) )
						|| ( ( hit_a3 <= (shot[loop_m].deg ) % 360 + 360 ) && ( hit_a4 >= (shot[loop_m].deg ) % 360 + 360 ) )
						|| ( ( hit_a3 <= (shot[loop_m].deg ) % 360 + 360 ) && ( hit_a4 >= (shot[loop_m].deg ) % 360 +  0 ) && ( hit_a3 >= hit_a4 ) )
						   )
					  && ( shot[loop_m].type > 0 ) && ( enemy[loop_j].type > 0 ) )
					{
						//ヒットエフェクトの追加
						float dir1 = cast( float )Hell_randInt(0, 360 );
						float dir2 = cast( float )Hell_randInt(0, 360 );
						float pos_x = 240.0 + Hell_cosEx( enemy[loop_j].deg + field_deg ) * enemy[loop_j].distance * zoome;
						float pos_y = 240.0 + Hell_sinEx( enemy[loop_j].deg + field_deg ) * enemy[loop_j].distance * zoome;

//						test1 = hit_a1;
//						test2 = hit_a2;
//						test3 = shot[loop_m].atk;
//	//					test3 = (shot[loop_m].deg ) % 360 + 360;
						
						
						if ( shot[loop_m].atk >= enemy[loop_j].hp )
						{
							
							hit_se = 1; //撃墜
							point_count++;
							create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_ATK, pos_x, pos_y, dir2 + 180, 0, 128, 128, 255 , enemy[loop_j].size/2 );
							
							//得点
							if ( enemy[loop_j].type == 1  )
							{
								point[point_count % 100].score = 100 * cast(int)enemy[loop_j].size ; 
							}
							else if ( enemy[loop_j].type == 2 )	//硬いやつ
							{
								point[point_count % 100].score = 300 ; 
							}
							else if ( enemy[loop_j].type == 3 )	//横移動
							{
								point[point_count % 100].score = 500 ; 
							}
							else if ( enemy[loop_j].type == 4 )	//編隊A
							{
								point[point_count % 100].score = 700 ;
							}
							else if ( enemy[loop_j].type == 5 )	//横移動2
							{
								point[point_count % 100].score = 500 ;
							}
							else if ( enemy[loop_j].type == 6 )	//編隊B
							{
								point[point_count % 100].score = 700 ;
							}
							else if ( enemy[loop_j].type == 7 )	//高速
							{
								point[point_count % 100].score = 500 ;
							}
							
							point[point_count % 100].score = point[point_count % 100].score * (combo+10)/10 * ( 1 + burst );
							game_score = game_score + point[point_count % 100].score ;
							point[point_count % 100].wait = 50;
							point[point_count % 100].x = 200 + point_count % 10 * 5;
							point[point_count % 100].y = 150 + loop_j % 10 * 5;
							point[point_count % 100].x = 200 + cast(int)(Hell_cosEx( enemy[loop_j].deg + field_deg ) * enemy[loop_j].distance * zoome  - char_size * enemy[loop_j].size - ( char_size * enemy[loop_j].size  * ( zoome - 1 )) + char_size * enemy[loop_j].size/2 * zoome);
							point[point_count % 100].y = 240 + cast(int)(Hell_sinEx( enemy[loop_j].deg + field_deg ) * enemy[loop_j].distance * zoome  - char_size * enemy[loop_j].size - ( char_size * enemy[loop_j].size  * ( zoome - 1 )) + char_size * enemy[loop_j].size/2 * zoome);
							
							if ( shot[loop_m].type == 2 )	//誘爆精製 ver1.01
							{
								shot_on = 0;
								for ( loop_k = loop_m ; loop_k < 100 ; loop_k ++ )
								{
									if (  ( shot[loop_k].type == 0 ) && ( shot_on == 0 ) )
									{
									shot_on = 1;
									
									shot[loop_k].type 		= 99;
									shot[loop_k].num 		= loop_k;
									shot[loop_k].deg 		= enemy[loop_j].deg ;
									shot[loop_k].distance 	= enemy[loop_j].distance;
									shot[loop_k].reach	 	= 480;
									shot[loop_k].move 		= 0;
									shot[loop_k].size 		= enemy[loop_j].size;	//zoome*3;
									shot[loop_k].atk 		= shot[loop_m].atk;		//cast(int)((3-zoome)*3)-2;
									shot[loop_k].hp 		= 1;
									shot[loop_k].speed 		= 0;
									shot[loop_k].wait 		= 30;					//誘爆用時間
									
									}
								}
							}
								
							enemy[loop_j].type = 0;
							enemy_count2 --;
							enemy[loop_j].distance = 1000;
//							enemy[loop_j].wait = 180;
							
							if ( shot[loop_m].type == 2 ) 
							{
								create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE, pos_x, pos_y, dir2 + 180, 0, 255, 255, 50 , shot[loop_m].size/2 );
								combo = combo + ( cast(int)enemy[loop_j].size - 1 );
							}
							else
							{
								combo ++;
							}
							
							combo_timer = 180;
							combo_timer = 120;	//ver1.01
						}
						else
						{
							create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE, pos_x, pos_y, dir2 + 180, 0, 128, 128, 255 , enemy[loop_j].size/2 );
							Hell_playWAV( "bom2", 0, -1 );	//カスリ
							enemy[loop_j].hp = enemy[loop_j].hp - shot[loop_m].atk;
						}
						
						if ( hit_se == 1 )
						{
							Hell_playWAV( "bom1", 0, -1 ); //撃墜
						}
						
						if ( shot[loop_m].type == 1 ) 
						{
							shot[loop_m].type = 0;
						}
						else if ( shot[loop_m].type == 2 )
						{
							shot[loop_m].atk = shot[loop_m].atk - enemy[loop_j].hp;
							if ( shot[loop_m].atk <= 0 )
							{
								shot[loop_m].type = 0;
							}
						}
						
					}
					else	//ヒットしていない
					{
					}
				}
			}
		}
//		test4 = 360 - ( field_deg - 270) % 360;
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	ゲーム情報、システムの描画 #20B
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		int j;
		int k;
		int c2 = 0;
		int combo_y = 150;
		int lock_y = -100;
		
/*		
		//★★★ debug Disp ★★★
		Hell_drawFont( "DEBUG" , 400, 180 , 2 , 255, 0,255);
		Hell_drawFont( std.string.toString( test1 ) , 400, 200, 2 , 255,255,255);
		Hell_drawFont( std.string.toString( test2 ) , 400, 220, 2 , 255,255,255);
		Hell_drawFont( std.string.toString( test3 ) , 400, 240, 2 , 255,255,255);
		Hell_drawFont( std.string.toString( test4 ) , 400, 260, 2 , 255,255,255);
		Hell_drawFont( std.string.toString( enemy_count2 ) , 400, 280, 2 , 255,255,255);
		
//		Hell_drawFont( std.string.toString( Hell_getMouseX ) , 400, 220, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( Hell_getMouseY ) , 450, 220, 2 , 255,255,255);
*/


		player_draw();
		enemy_draw();
		shot_draw();
		effect_draw( );

		Hell_drawTexture("waku"		//視界範囲
			, 0
			, 0
			, 0
			, 0
			, 480 , 480
			, 1 , 1
			, 0
			,255, 255, 255, 255 );

		Hell_drawTexture("waku"		//右側のBG
			, 480
			, 0
			, 481
			, 0
			, 10 , 480
			, 50 , 1
			, 0
			,255, 255, 255, 255 );
	
		Hell_setAlpha(HELL_ALPHA_NORMAL);

		Hell_drawFont( "HI SCORE" , 450, 40 , 1.5 , 255,255,255);
		str = std.string.format( "%08d", hi_score[mode] );					//ハイスコア表示
		Hell_drawFont( str , 460, 60 , 2 , 255,255,255);

		Hell_drawFont( "SCORE" , 450, 80 , 1.5 , 255,255,255);
		str = std.string.format( "%08d", game_score );						//スコア表示
		Hell_drawFont( str , 460, 100 , 2 , 255,255,255);

		Hell_drawRect( 500, 170,	100, 10,	0, 0, 	0, 0, 0, 150);							//COMBOゲージ枠
		Hell_drawRect( 500, 170,	(combo_timer*100/180)+1, 10,	0, 0, 	200,200,0, 150);	//COMBOゲージ
		Hell_drawFont( "COMBO" , 480, 160 , 1.5 , 255,255,  0);									//コンボ表示
		Hell_drawFont( std.string.toString( combo ) , 560, 160, 2 , 255,255,255);
		Hell_drawFont( "BURST" , 480, 180 , 1.5 , 255,255,  0);									//コンボ表示
		Hell_drawFont( std.string.toString( burst ) , 560, 180, 2 , 255,255,255);

		for ( loop_j = 0 ; loop_j < 100 ; loop_j ++ )
		{
			if ( point[loop_j].wait > 0 )
			{
				Hell_drawFont( std.string.toString( point[loop_j].score ) 
				, point[loop_j].x , point[loop_j].y + point[loop_j].wait/2, 2 , 5*point[loop_j].wait, 5*point[loop_j].wait, 0);
				point[loop_j].wait --;
			}
		}
		
		
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );				//time表示
			Hell_drawFont( str , 450, 430 , 1.5 , 255,255,255);
			str = std.string.format( "%03d", cast(int)( (game_time_count + 59) / 60 ) );	//秒表示
			Hell_drawFont( str , 550, 450 , 2 , 255,255,0);
		}

		Hell_drawFont( "LIFE ",450, 370 , 1.5 , 0,255,0);
		Hell_drawRect( 500, 380,	100, 10,	0, 0, 	0, 0, 0, 150);			//LIFEゲージ枠
		Hell_drawRect( 500, 380,	life, 10,	0, 0, 	0,255,0, 150);			//LIFEゲージ
	
		Hell_drawFont( "Ver. 1.02 ",520, 470 , 1.0 , 255,255,200);
	
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	プレイヤーの表示 	120516-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void player_draw( )		
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		if ( ( zoome >= 1.95 ) && ( zoome < 2 ) )
		{
			create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE, 240, 240, 0, 0, 128, 128, 255 , 16 );
		}
		
		if ( life > 0 )
		{
		Hell_drawTexture("char"
			, 240 - player[0].size - ( player[0].size * ( zoome - 1 ))
			, 240 - player[0].size - ( player[0].size * ( zoome - 1 ))
			, 32 * ( 11 + player[0].ani )			
			, 32 * 0			
			, 32 , 32
			, zoome ,zoome 		
			, 0 		
			,255, 255, 255, 255 );
			
		}
		
		int alert_red = 0;
		int alert_blue = 150;
		for ( loop_m = 1 ; loop_m < 300 ; loop_m++ )
		{
			if ( ( alert_red < 250 ) && ( ( enemy[loop_m].type == 4 ) || ( enemy[loop_m].type == 6 ) ) )
			{
				alert_red = alert_red + 10;
				alert_blue = alert_blue - 5;
			}
		}

		int waku;
		for ( loop_m = 1 ; loop_m < 10 ; loop_m++ )
		{
		waku = loop_m * 3;
		Hell_drawTexture("char"
			, 240 - player[0].size - ( player[0].size * ( zoome* waku - 1 )) 
			, 240 - player[0].size - ( player[0].size * ( zoome* waku - 1 )) //- zoome * 32
			, 32 * 2			
			, 32 * 3			
			, 32 , 32
			, zoome * waku ,zoome * waku		
			, -field_deg + 30 * loop_m 			+ game_time_count * ( ( alert_red > 0) + 1 )
//			, game_time_count *2		
			,alert_red, 0, alert_blue, 200 - loop_m * 20 );
		Hell_drawTexture("char"
			, 240 - player[0].size - ( player[0].size * ( zoome* waku - 1 )) 
			, 240 - player[0].size - ( player[0].size * ( zoome* waku - 1 )) //- zoome * 32
			, 32 * 2			
			, 32 * 3			
			, 32 , 32
			, zoome * waku ,zoome * waku		
			, -field_deg - 30 * loop_m + 15 	- game_time_count		
//			, game_time_count *2		
			,alert_red, 0, alert_blue, 200 - loop_m * 20 );
			 //* ( ( alert_red > 0) * 2 - 1 ) 逆回転の仕組みメモ
		}
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	enemyの表示 	120523-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void enemy_draw( )		
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);

		int j;
		for ( j = 0 ; j < 300 ; j++ )
		{
			Hell_drawTexture("char"
				, 240 + Hell_cosEx( enemy[j].deg + field_deg ) * enemy[j].distance * zoome  - char_size * enemy[j].size - ( char_size * enemy[j].size  * ( zoome - 1 )) + char_size * enemy[j].size/2 * zoome
				, 240 + Hell_sinEx( enemy[j].deg + field_deg ) * enemy[j].distance * zoome  - char_size * enemy[j].size - ( char_size * enemy[j].size  * ( zoome - 1 )) + char_size * enemy[j].size/2 * zoome
				, 256 + 16 * enemy[j].type
				, 32 
				, char_size , char_size
				, zoome * enemy[j].size , zoome * enemy[j].size
				, 270 - enemy[j].deg - field_deg 
				,255, 255, 255, 255 );
			
			if (( enemy[j].distance < 240 / 0.5 +120 ) && ( enemy[j].distance > 240 / zoome ) && ( enemy[j].type > 0 ) )
			{
			Hell_drawTexture("char"										//ALERT表示
				, 240 + Hell_cosEx( enemy[j].deg + field_deg ) * 235 -8
				, 240 + Hell_sinEx( enemy[j].deg + field_deg ) * 235 -8
				, 288
				, 0 
				, char_size , char_size
				, 1 , 1
				, 270 - enemy[j].deg - field_deg 
				,255, 255, 255, 255 );
			}
		}		
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	SHOTの表示 	120611-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void shot_draw( )		
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);

		int j;
		float deg;
		float size;
		for ( j = 0 ; j < 100 ; j++ )
		{
			if ( shot[j].type == 1 )
			{
			Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
			Hell_drawTextureEx("shot"			//shot表示
				, 240 + Hell_cosEx( shot[j].deg + field_deg ) * shot[j].distance * zoome  - char_size * shot[j].size - ( char_size * shot[j].size  * ( zoome - 1 )) + char_size * shot[j].size/2 * zoome *2
				, 240 + Hell_sinEx( shot[j].deg + field_deg ) * shot[j].distance * zoome  - char_size * shot[j].size - ( char_size * shot[j].size  * ( zoome - 1 )) + char_size * shot[j].size/2 * zoome *2
				, 0 
				, 0 
				, char_size * 8 , char_size * 8
				, zoome * shot[j].size / 8 , zoome * shot[j].size / 8
				, 270 - shot[j].deg - field_deg 
				,255, 255, 255, 255 );
			Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
			}
			if ( shot[j].type == 2 )
			{
			Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
			Hell_drawTextureEx("shot"			//shield表示
				, 240 + Hell_cosEx( shot[j].deg + field_deg ) * shot[j].distance * zoome  - char_size * shot[j].size - ( char_size * shot[j].size  * ( zoome - 1 )) + char_size * shot[j].size/2 * zoome *2
				, 240 + Hell_sinEx( shot[j].deg + field_deg ) * shot[j].distance * zoome  - char_size * shot[j].size - ( char_size * shot[j].size  * ( zoome - 1 )) + char_size * shot[j].size/2 * zoome *2
				, 0 
				, 0 
				, char_size * 8 , char_size * 8
				, zoome * shot[j].size / 8 , zoome * shot[j].size / 8
				, 270 - shot[j].deg - field_deg 
				, 255, 255, 255, 200 );
			Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
			}
		}		
			if ( (keypad.isPressCancel()) && ( life >= 0 ) && ( ( stage_start_count == 0 ) && ( game_time_count > 0 ) ) 
				&& ( charge_wait >50 ) )		//2ボタン 
		{
			Hell_drawTexture("char"
				, 240 - player[0].size - ( player[0].size * ( zoome*2 - 1 )) 
				, 240 - player[0].size - ( player[0].size * ( zoome*2 - 1 )) //- zoome * 32
				, 32 * 2			
				, 32 * 3			
				, 32 , 32
				, zoome*2 ,zoome*2 		
	//			, field_deg 		
				, game_time_count * 2		
				,255, 255, 0, charge_wait );
			Hell_drawTexture("char"
				, 240 - player[0].size - ( player[0].size * ( zoome*2 - 1 )) 
				, 240 - player[0].size - ( player[0].size * ( zoome*2 - 1 )) //- zoome * 32
				, 32 * 2			
				, 32 * 3			
				, 32 , 32
				, zoome*2 ,zoome*2 		
	//			, field_deg 		
				, game_time_count * 2 + 45		
				,255, 255, 0, charge_wait );
			if ( ( zoome > 0.5 ) && ( zoome < 2) )
			{
				deg = zoome * 90;
				size = zoome * 2;
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("shot"			//shot表示
					, 240 + Hell_cosEx( deg +90 ) * (60 - 30 * zoome) * zoome  - char_size * size - ( char_size * size * ( zoome - 1 )) + char_size * size/2 * zoome *2
					, 240 + Hell_sinEx( deg +90 ) * (60 - 30 * zoome) * zoome  - char_size * size - ( char_size * size * ( zoome - 1 )) + char_size * size/2 * zoome *2
					, 0 
					, 0 
					, char_size * 8 , char_size * 8
					, zoome * size / 8 , zoome * size / 8
					, 0 
					,255, 255, 255, 255 );
				Hell_drawTextureEx("shot"			//shot表示
					, 240 + Hell_cosEx( -deg +90 ) * (60 - 30 * zoome) * zoome  - char_size * size - ( char_size * size * ( zoome - 1 )) + char_size * size/2 * zoome *2
					, 240 + Hell_sinEx( -deg +90 ) * (60 - 30 * zoome) * zoome  - char_size * size - ( char_size * size * ( zoome - 1 )) + char_size * size/2 * zoome *2
					, 0 
					, 0 
					, char_size * 8 , char_size * 8
					, zoome * size / 8 , zoome * size / 8
					, 0 
					,255, 255, 255, 255 );
				Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
			}

		}
	}
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	爆発の表示 	120623-   
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	enum EFFECT_TYPE
	{
		EN_EFFECT_TYPE_ATTACK,
		EN_EFFECT_TYPE_YELL1,
		EN_EFFECT_TYPE_YELL2,
		EN_EFFECT_TYPE_YELL3,
		EN_EFFECT_TYPE_YELL3_2,
		EN_EFFECT_TYPE_ATK,
		EN_EFFECT_TYPE_GRAZE,
		EN_EFFECT_TYPE_CHARGE,
	}
	
	void create_effect( int type, float x, float y, float dir, float speed, int r, int g, int b ,float size )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].size = size;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//

				//タイプによってパラメータを分けるといいかも
				effect[i].r = r;	//色
				effect[i].g = g;	//色
				effect[i].b = b;	//色
				effect[i].zoom_x = 0.3;	//拡大率
				effect[i].zoom_y = 0.3;	//拡大率
				effect[i].dec_alpha = 8;	//透明度
				effect[i].move[] = 0;	//汎用バッファ
				
				switch( effect[i].type )
				{
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATTACK:
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL1:
					//YELLエフェクト1
					effect[i].zoom_x = 0.3;	//拡大率
					effect[i].zoom_y = 0.3;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL2:
					//YELLエフェクト2
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3:
					//YELLエフェクト3
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					effect[i].alpha = 255/2;	//透明度
					effect[i].dec_alpha = 8/2;	//透明度
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3_2:
					//YELLエフェクト3
					effect[i].zoom_x = 0.3;	//拡大率
					effect[i].zoom_y = 0.3;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATK:		//爆発
					//YELLエフェクト5
					effect[i].zoom_x = 1;	//拡大率
					effect[i].zoom_y = 1;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE:		//カスリ
					//YELLエフェクト6
					effect[i].zoom_x = 1;	//拡大率
					effect[i].zoom_y = 1;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE:		//溜め
					//YELLエフェクト7
					effect[i].zoom_x = 1;	//拡大率
					effect[i].zoom_y = 1;	//拡大率
					effect[i].dec_alpha = 4;	//透明度
					break;
				default:
					break;
				}
				
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		burst = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if (( effect[i].exist != 0 ) && ( effect[i].type == EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE ) )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x * zoome , effect[i].zoom_y * zoome
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
			if (( effect[i].exist != 0 ) && ( effect[i].type == EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE ) )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x * zoome , effect[i].zoom_y * zoome
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
			if (( effect[i].exist != 0 ) && ( effect[i].type == EFFECT_TYPE.EN_EFFECT_TYPE_ATK ) )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTexture("atk"
					, effect[i].pos_x -20 * zoome * effect[i].size
					, effect[i].pos_y -20 * zoome * effect[i].size
					, cast(int)((255-effect[i].alpha)/16)*40
					, 0
					, 40, 40
					, effect[i].zoom_x * zoome * effect[i].size , effect[i].zoom_y * zoome * effect[i].size
					, 0
					, 255, 255, 255, 255 );
				burst ++;	//爆発中の数
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_sinEx( effect[i].dir + field_deg ) * effect[i].speed * zoome;
				float vy = Hell_cosEx( effect[i].dir + field_deg ) * effect[i].speed * zoome;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				//種類を増やす場合はtypeで処理をわける

				switch( effect[i].type )
				{
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATTACK:
					effect[i].zoom_x -= 0.01;	//
					effect[i].zoom_y -= 0.01;	//
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL1:
					//YELLエフェクト1
					effect[i].zoom_x -= 0.005;	//
					effect[i].zoom_y -= 0.005;	//
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL2:
					//YELLエフェクト2
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3:
					//YELLエフェクト3
					effect[i].zoom_x -= 0.005;	//
					effect[i].zoom_y -= 0.005;	//
					effect[i].dir -= 2;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3_2:
					//YELLエフェクト3_2
					effect[i].zoom_x -= 0.01;	//
					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATK:
					//YELLエフェクトATK
//					effect[i].zoom_x -= 0.01;	//
//					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE:
					//YELLエフェクトATK
//					effect[i].zoom_x -= 0.01;	//
//					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE:
					//YELLエフェクトATK
//					effect[i].zoom_x -= 0.01;	//
//					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				default:
					break;
				}

				if ( effect[i].zoom_x < 0.0 )
				{
					effect[i].zoom_x = 0.0;
				}
				if ( effect[i].zoom_y < 0.0 )
				{
					effect[i].zoom_y = 0.0;
				}

				effect[i].alpha -= effect[i].dec_alpha;	//透明度
				
				if ( effect[i].alpha < 0 )
				{
					effect[i].exist = 0;	//消える 
				}
			}
		}
	}
	//方向と速度から位置を求める
	POS GetDirSpd_To_Position( float dir, float spd, int x, int y)
	{
		POS rc;

		float vx = Hell_sinEx( dir ) * spd;
		float vy = Hell_cosEx( dir ) * spd;

		rc.x = x + vx;
		rc.y = y + vy;
		
		return( rc );
	}

	//-----------------------------------------------------------------------------
	//	ポーズの処理   #09A
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画 #09B
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
}


