﻿/********************************************************************************/
/* 	state.d																		*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2012/02/29														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://www.geocities.jp/dij4121/alpha/							*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2011/04/30	初版															*/
/*	2012/08/03	ver1.02															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

/* ライブラリのインポート *******************************************************/
private import hell2;		// dHell2ライブラリ
private import vector;
private import keypad;
private import actor;
private import clickable;
private import gamecore;

private import std.string;
private import std.math;
private import std.math2;
private import std.stream;
private import std.thread;

import config;

/* グローバル定数定義 ***********************************************************/
GameState g_gamestate = null;


/* load *************************************************************************/
/*	リソースの読み込み															*/
/*-引数-------------------------------------------------------------------------*/
/*	なし																		*/
/*-返り値-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/
void load()
{
	Hell_loadTexture("font","resource/font/font.bmp" , [255,255,255]);
	Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);
	Hell_loadTexture("char","resource/image/char1.bmp" , [0,255,0]);
	Hell_loadWAV("select",        "resource/sound/select.wav");
	
	Hell_write("resource loaded.\n");
}

/* GameState ********************************************************************/
/*	ゲーム全体の状態遷移を管理するクラス										*/
/********************************************************************************/
class GameState
{
private:
	int msg;				// リクエストメッセージ
public:
	enum
	{
		MSG_NONE = 0,
		MSG_REQ_LOGO,			// ロゴ状態へ　行きたい
		MSG_REQ_TITLE,			// タイトル状態へ　行きたい
		MSG_REQ_GAME,			// ゲーム
		
		MSG_EXIT,				//アプリケーションの終了
	}
	
	void move(){}
	void draw(){}
	
	// 設定
	void setMsg(int m)
	{
		msg = m;
	}
	// 取得
	int getMsg()
	{
		return msg;
	}
}



bool loop()
{
	bool is_exit = true;	//アプリケーションの終了
	if(g_gamestate)
	{
		// メッセージ指示による状態遷移
		switch(g_gamestate.msg)
		{
			case GameState.MSG_NONE:
				break;
			case GameState.MSG_REQ_LOGO:
				g_gamestate = new LogoMain();
				break;
			case GameState.MSG_REQ_TITLE:
				g_gamestate = new TitleMain();
				break;
			case GameState.MSG_REQ_GAME:
				g_gamestate = new GameMain();
				break;
			case GameState.MSG_EXIT:
			default:
				is_exit = false;
				Hell_write("Unknown msg at loop.");
		}
	}
	else
	{
		// 初期状態
		g_gamestate = new LogoMain();
		Hell_write("Exec loop.\n");
	}
	
	g_gamestate.move();
	g_gamestate.draw();
	
	return( is_exit );
}

/* TitleMain ********************************************************************/
/*	タイトルの状態																*/
/********************************************************************************/

class TitleMain : GameState
{
public:
	int timer;
	Keypad keypad;					// キーボード/ゲームパッド取得用
	int init_flag;
	ConfigParser savedata;			// セーブデータ
	int hi_score[10];
	int star;
	int key_wait;
	int bgm_select = 1;
	int maxstar;
	int sel ;
	
	this()
	{
Hell_write( "TitleMain\n" );
		setMsg( GameState.MSG_NONE );
		timer = 0;
		init_flag = 0;
		star = 0;

		keypad = new Keypad();
		//セーブデータ
		hi_score[0] = 0;
		savedata = new ConfigParser();
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         0);
			savedata.set("HI_SCORE1",         0);
			savedata.set("HI_SCORE2",         0);
			savedata.set("HI_SCORE3",         0);
			savedata.set("HI_SCORE4",         0);
			savedata.set("HI_SCORE5",         0);
			savedata.set("HI_SCORE6",         0);
			savedata.set("HOSHI",         1);
			savedata.set("SELECT_HOSHI",         0);
			savedata.write();
		}
		hi_score[0] = savedata.getint("HI_SCORE");
		hi_score[1] = savedata.getint("HI_SCORE1");
		hi_score[2] = savedata.getint("HI_SCORE2");
		hi_score[3] = savedata.getint("HI_SCORE3");
		hi_score[4] = savedata.getint("HI_SCORE4");
		hi_score[5] = savedata.getint("HI_SCORE5");
		hi_score[6] = savedata.getint("HI_SCORE6");
		maxstar = savedata.getint("HOSHI");
		bgm_select = savedata.getint("SELECT_HOSHI");
		
	}
	
	void move()
	{
		if ( init_flag == 0 )
		{
			init_flag = 1;
			Hell_loadWAV("select",      "resource/sound/select.wav");
//			Hell_loadTexture("title","resource/image/title.bmp" , [0,255,0]);
//			Hell_playBgm( "resource/sound/title.ogg", -1, 0 );
			Hell_stopBgm( 1000 );
		}
		timer++;
		
//		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) >= 0 ) )
		if(keypad.isPushEnter())		//１ボタン
		{
			setMsg(GameState.MSG_REQ_GAME);
		}
/*
		if(keypad.isPushCancel())		//2ボタン
		{
			savedata.set("SELECT_HOSHI",         star);
			savedata.write();

			Hell_SetGameflag( 0, 1 );	//リプレイモードON
			Hell_SetGameflag( 1, star );	//星番号
			setMsg(GameState.MSG_REQ_GAME);
		}
*/
		if ( (keypad.isPushRight()) && ( key_wait == 0 ) )
		{
			Hell_playWAV( "select", 0, -1 );
			key_wait = 1;
			bgm_select ++;
			if ( bgm_select > 2 )
			{
				bgm_select = 1;
			}
		}
		else if( (keypad.isPushLeft()) && ( key_wait == 0 ) )
		{
			Hell_playWAV( "select", 0, -1 );
			key_wait = 1;
			bgm_select --;
			if ( bgm_select < 1 )
			{
				bgm_select = 2;
			}
		}
		else
		{
			key_wait = 0;
		}
	}
	
	void draw()
	{
		int min;
		int sec;
		int msec;
		char[] str;
		
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
/*	
		Hell_drawTexture("title"
			, 0
			, 0
			, 0
			, 0
			, 640 , 480
			, 1.0 , 1.0
			, 0 );

		Hell_drawRect( 50, 50,
				540 , 400,
				0, 0, 
				0, 0, 100, 
				255);							//MENU枠

*/

		square_draw( ( timer / 2) % 360 ,timer );
		
		Hell_drawFont( "Transform Edge"  , 100, 130 , 4 , 255,255, 0);

		Hell_drawFont( "START  : Z KEY"  		, 200, 250 , 2.5 , 255,255,255);
		
		if ( bgm_select == 1 )
		{
			Hell_drawFont( "BGM : robiopsys"   			, 220, 290 , 2 , 255,255,255);
		}
		else if ( bgm_select == 2 )
		{
			Hell_drawFont( "BGM : natsuki burst2"   	, 220, 290 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont( "BGM : robiopsys"   			, 220, 290 , 2 , 255,255,255);
		}
		Hell_drawFont( "L - R  : ROLL"   		, 180, 320 , 2 , 255,255,255);
		Hell_drawFont( "DOWN   : 180 TURN"	, 180, 340 , 2 , 255,255,255);
		Hell_drawFont( "Z (1)  : NORMAL SHOT" 	, 180, 360 , 2 , 255,255,255);
		Hell_drawFont( "X (2)  : CHARGE SHOT" 	, 180, 380 , 2 , 255,255,255);
		Hell_drawFont( " hi-score"  , 150, 210 , 2.5 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[1] );
		Hell_drawFont( str , 350, 210 , 2.5 , 255,255,255);

		Hell_SetGameflag( 10 , bgm_select );
		
//		Hell_drawFont( std.string.toString(Hell_GetGameflag(10)) , 300, 30 , 4 , 255,255,255);
//		min = ( hi_score / 60 ) / 60;
//		sec = ( hi_score / 60 ) % 60;
//		msec = hi_score % 60;
//		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
//		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);

//		Hell_drawFont("HOGE" , 240, 160 , 4 , 255,255,255);
		Hell_drawFont("ALPHA SECRET BASE 2012" , 220, 480-20 , 2 , 255,255,255);
	}
}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	タイトル装飾表示 	120723-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void square_draw( int ring , int timer)
	{
		int size = 16;
		float zoome = 0.5;
		int loop_m;
		int field_deg = 0;
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);
/*
		Hell_drawTexture("char"
			, 240 - size - ( size * ( zoome - 1 ))
			, 240 - size - ( size * ( zoome - 1 ))
			, 32 * ( 11 + 0 )			
			, 32 * 0			
			, 32 , 32
			, zoome ,zoome 		
			, 0 		
			,255, 255, 255, 255 );
*/
		
		int alert_red = 0;
		int alert_blue = 150;
		
		alert_red  =  ( ( (timer / 250) % 2 == 0 ) * timer % 250 )  + ( ( (timer / 250) % 2 == 1 ) * (250 - timer % 250) )+5;
		alert_blue =  ( ( (timer / 250) % 2 == 1 ) * timer % 250 )  + ( ( (timer / 250) % 2 == 0 ) * (250 - timer % 250) )+5;
		
		int waku;
		for ( loop_m = 1 ; loop_m < 10 ; loop_m++ )
		{
		waku = loop_m * 3;
		Hell_drawTexture("char"
			, 320 - size - ( size * ( zoome* waku - 1 )) 
			, 240 - size - ( size * ( zoome* waku - 1 ))
			, 32 * 2			
			, 32 * 3			
			, 32 , 32
			, zoome * waku ,zoome * waku		
			, -field_deg + 30 * loop_m 			+ ring * ( ( alert_red > 0) + 1 )
			,alert_red, 0, alert_blue, 200 - loop_m * 20 );
		Hell_drawTexture("char"
			, 320 - size - ( size * ( zoome* waku - 1 )) 
			, 240 - size - ( size * ( zoome* waku - 1 )) //- zoome * 32
			, 32 * 2			
			, 32 * 3			
			, 32 , 32
			, zoome * waku ,zoome * waku		
			, -field_deg - 30 * loop_m + 15 	- ring		
			,alert_red, 0, alert_blue, 200 - loop_m * 20 );
			 //* ( ( alert_red > 0) * 2 - 1 ) 逆回転の仕組みメモ
		}
	}

/* TitleMain ********************************************************************/
/*	ロゴの状態																	*/
/********************************************************************************/

class LogoMain : GameState
{
public:
	int timer;
	Keypad keypad;					// キーボード/ゲームパッド取得用
	int init_flag;
	
	this()
	{
		setMsg( GameState.MSG_NONE );
		timer = 0;
		init_flag = 0;
		
		keypad = new Keypad();
//		menu = new ClickablePool();
//		menu.add("START" , new Vec3(280 , 400 , 0) , new Vec3(96 , 32 , 0));
		
	}
	
	void move()
	{
		if ( init_flag == 0 )
		{
			init_flag = 1;
			Hell_loadTexture("logo","resource/image/logo.bmp" , [0,255,0]);
		}
		timer++;
		
//		if ( ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) )|| ( timer > 180 ) )
		if ( ( keypad.isPushEnter() )|| ( timer > 180 ) )
		{
//			Hell_playBgm( "resource/sound/99.ogg" );
			setMsg(GameState.MSG_REQ_TITLE);
			//１ボタン
		}
	}
	
	void draw()
	{
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		Hell_drawTexture("logo"
			, 160
			, 120
			, 0
			, 0
			, 320 , 320
			, 1.0 , 1.0
			, 0 );
				
	}
}

